package com.zhaoliangsz.grainsearch.controller;


import org.springframework.web.bind.annotation.RequestMapping;
import lombok.extern.slf4j.Slf4j;
import javax.annotation.Resource;
import com.zhaoliangsz.grainsearch.service.IInventoryTableService;
import org.springframework.web.bind.annotation.*;
import com.zhaoliangsz.grainsearch.basic.exception.ServiceException;
import com.zhaoliangsz.grainsearch.basic.result.PageResult;
import com.zhaoliangsz.grainsearch.domain.entity.InventoryTable;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zyw
 * @since 2023-09-27 10:12:06
 */
@RestController
@Slf4j
@RequestMapping("/v1/inventoryTable")
public class InventoryTableController {
    @Resource
    private IInventoryTableService myIInventoryTableService;
    /**
     * 获取InventoryTable
     * @return
     */
    @GetMapping
    public PageResult<InventoryTable> queryInventoryTableList(InventoryTable queryInventoryTable) throws ServiceException {
        log.info("[InventoryTableController.queryInventoryTableList]获取InventoryTable列表开始参数:{}",queryInventoryTable);
        PageResult<InventoryTable> page = myIInventoryTableService.queryInventoryTableList(queryInventoryTable);
        log.info("[InventoryTableController.queryInventoryTableList]获取InventoryTable列表结束结果:{}",page);
        return page;
    }
    /**
     * 新增InventoryTable
     * @return
     */
    @PostMapping
    public String addInventoryTable(@RequestBody InventoryTable addInventoryTable) throws ServiceException {
        log.info("[InventoryTableController.addInventoryTable]新增InventoryTable开始addInventoryTable:{}",addInventoryTable);
        String result = myIInventoryTableService.addInventoryTable(addInventoryTable);
        log.info("[InventoryTableController.addInventoryTable]新增InventoryTable结束结果:{}",result);
        return result;
    }
    /**
     * 编辑InventoryTable
     * @return
     */
    @PutMapping
    public String editInventoryTable(@RequestBody InventoryTable editInventoryTable) throws ServiceException {
        log.info("[InventoryTableController.editInventoryTable]编辑InventoryTable开始参数:{}",editInventoryTable);
        String result = myIInventoryTableService.editInventoryTable(editInventoryTable);
        log.info("[InventoryTableController.editInventoryTable]编辑InventoryTable结束结果:{}",result);
        return result;
    }
    /**
     * 删除InventoryTable
     * @return
     */
    @DeleteMapping
    public String deleteInventoryTable(@RequestBody InventoryTable deleteInventoryTable) throws ServiceException {
        log.info("[InventoryTableController.deleteInventoryTable]删除InventoryTable开始参数:{}",deleteInventoryTable);
        String result = myIInventoryTableService.deleteInventoryTable(deleteInventoryTable);
        log.info("[InventoryTableController.deleteInventoryTable]删除InventoryTable结束结果:{}",result);
        return result;
    }
}

